#include "testlib.h"
#include <algorithm>

using namespace std;

const int num_of_groups = 7, MAX_N = 200'000, MAX_C = 1'000'000'000;
const int N[num_of_groups] = {MAX_N, 1000, MAX_N, MAX_N, MAX_N, MAX_N, MAX_N};
const int Q[num_of_groups] = {MAX_N, 1000, MAX_N, MAX_N, MAX_N, MAX_N, MAX_N};
const int SUM_K[num_of_groups] = {MAX_N, 1000, MAX_N, MAX_N, MAX_N, MAX_N, MAX_N};


int main(int argc, char** argv) {
    registerValidation(argc, argv);

    int gr_n = validator.group().empty() ? 0 : atoi(validator.group().c_str());

    int n = inf.readInt(2, N[gr_n], "n");
    inf.readSpace();
    int q = inf.readInt(1, Q[gr_n], "q");
    inf.readEoln();
    for (int i = 2; i <= n; i++) {
        int pi = inf.readInt(1, i - 1, "pi");
        if (gr_n == 4)
            ensuref(pi == i - 1, "tree isn't a bamboo");
        if (gr_n == 5)
            ensuref(pi == i / 2, "tree isn't binary");
        if (i < n)
            inf.readSpace();
    }
    inf.readEoln();
    for (int i = 1; i <= n; i++) {
        int ti = inf.readInt(1, n, "ti");
        if (gr_n == 2)
            ensuref(ti == 1, "ti is not equal to 1, since D mode is on");
        if (i < n)
            inf.readSpace();
    }
    inf.readEoln();
    for (int i = 1; i <= n; i++) {
        int ci = inf.readInt(1, MAX_C, "c");
        if (i < n)
            inf.readSpace();
    }
    inf.readEoln();
    int sum_k = 0;
    for (int i = 1; i <= q; i++) {
        int type = inf.readInt(1, 2, "type");
        inf.readSpace();
        if (type == 1) {
            if (gr_n == 2 || gr_n == 3) {
                ensuref(false, "B is on but there is a query of type 1");
            }
            inf.readInt(1, n, "v");
            inf.readSpace();
            inf.readInt(1, n, "new_t");
            inf.readEoln();
        } else {
            inf.readInt(1, n, "t");
            inf.readSpace();
            int k = inf.readInt(1, SUM_K[gr_n], "k");
            sum_k += k;
            ensuref(sum_k <= SUM_K[gr_n], "sum of k is more than limit for current group");
            inf.readSpace();
            vector<int> a(k);
            for (int j = 1; j <= k; j++) {
                a[j - 1] = inf.readInt(1, n, "aj");
                if (j < k)
                    inf.readSpace();
            }
            sort(a.begin(), a.end());
            for (int j = 0; j + 1 < k; j++) {
                ensuref(a[j] != a[j + 1], "there are same vertices in the query");
            }
            inf.readEoln();
        }
    }
    inf.readEof();
}
